wxPropertyGrid Class Reference | wxWidgets

| Version: 3.2.11

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
wxPropertyGrid Class Reference
Class List by Category » wxPropertyGrid

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.2/wxWidgets3.2-3.2.11-1.x86_64/src/wxWidgets-3.2.11/interface/wx/propgrid/propgrid.h>`

Inheritance diagram for wxPropertyGrid:
[legend]

## Detailed Description

wxPropertyGrid is a specialized grid for editing properties - in other words name = value pairs.

List of ready-to-use property classes include strings, numbers, flag sets, fonts, colours and many others. It is possible, for example, to categorize properties, set up a complete tree-hierarchy, add more than two columns, and set arbitrary per-property attributes.

Please note that most member functions are inherited and as such not documented on this page. This means you will probably also want to read wxPropertyGridInterface class reference.

See also wxPropertyGrid Overview.

# Window Styles

See wxPropertyGrid Window Styles.

# Event Handling

Please see wxPropertyGridEvent for the documentation of all event types you can use with wxPropertyGrid.

Remarks
  Use Freeze() and Thaw() respectively to disable and enable drawing. This will also delay sorting etc. miscellaneous calculations to the last possible moment.

##

Library: wxPropertyGrid
Category: wxPropertyGrid

Appearance:

wxMSW Appearance | wxGTK Appearance | wxOSX Appearance

## Public Member Functions
| wxPropertyGrid ()
| Two step constructor.
| wxPropertyGrid (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxPG_DEFAULT_STYLE, const wxString &name=wxPropertyGridNameStr)
| Constructor.
virtual | ~wxPropertyGrid ()
| Destructor.
void | AddActionTrigger (int action, int keycode, int modifiers=0)
| Adds given key combination to trigger given action.
bool | AddToSelection (wxPGPropArg id)
| Adds given property into selection.
void | BeginLabelEdit (unsigned int colIndex=0)
| Creates label editor wxTextCtrl for given column, for property that is currently selected.
bool | ChangePropertyValue (wxPGPropArg id, wxVariant newValue)
| Changes value of a property, as if from an editor.
void | CenterSplitter (bool enableAutoResizing=false)
| Centers the splitter.
virtual void | Clear ()
| Deletes all properties.
void | ClearActionTriggers (int action)
| Clears action triggers for given action.
virtual bool | CommitChangesFromEditor (wxUint32 flags=0)
| Forces updating the value of property from the editor control.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxPG_DEFAULT_STYLE, const wxString &name=wxPropertyGridNameStr)
| Two step creation.
void | DedicateKey (int keycode)
| Dedicates a specific keycode to wxPropertyGrid.
bool | EnableCategories (bool enable)
| Enables or disables (shows/hides) categories according to parameter enable.
void | EndLabelEdit (bool commit=true)
| Destroys label editor wxTextCtrl, if any.
bool | EnsureVisible (wxPGPropArg id)
| Scrolls and/or expands items to ensure that the given item is visible.
wxSize | FitColumns ()
| Reduces column sizes to minimum possible, while still retaining fully visible grid contents (labels, images).
wxTextCtrl * | GetLabelEditor () const
| Returns currently active label editor, NULL if none.
wxWindow * | GetPanel ()
| Returns wxWindow that the properties are painted on, and which should be used as the parent for editor controls.
wxColour | GetCaptionBackgroundColour () const
| Returns current category caption background colour.
wxFont & | GetCaptionFont ()
| Returns current category caption font.
wxColour | GetCaptionForegroundColour () const
| Returns current category caption text colour.
wxColour | GetCellBackgroundColour () const
| Returns current cell background colour.
wxColour | GetCellDisabledTextColour () const
| Returns current cell text colour when disabled.
wxColour | GetCellTextColour () const
| Returns current cell text colour.
unsigned int | GetColumnCount () const
| Returns number of columns currently on grid.
wxColour | GetEmptySpaceColour () const
| Returns colour of empty space below properties.
int | GetFontHeight () const
| Returns height of highest characters of used font.
wxPropertyGrid * | GetGrid ()
| Returns pointer to itself.
wxRect | GetImageRect (wxPGProperty *property, int item) const
| Returns rectangle of custom paint image.
wxSize | GetImageSize (wxPGProperty *property=NULL, int item=-1) const
| Returns size of the custom paint image in front of property.
wxPGProperty * | GetLastItem (int flags=wxPG_ITERATE_DEFAULT)
| Returns last item which could be iterated using given flags.
wxColour | GetLineColour () const
| Returns colour of lines between cells.
wxColour | GetMarginColour () const
| Returns background colour of margin.
int | GetMarginWidth () const
| Returns margin width.
wxPGProperty * | GetRoot () const
| Returns "root property".
int | GetRowHeight () const
| Returns height of a single grid row (in pixels).
wxPGProperty * | GetSelectedProperty () const
| Returns currently selected property.
wxPGProperty * | GetSelection () const
| Returns currently selected property.
wxColour | GetSelectionBackgroundColour () const
| Returns current selection background colour.
wxColour | GetSelectionForegroundColour () const
| Returns current selection text colour.
wxPGSortCallback | GetSortFunction () const
| Returns the property sort function (default is NULL).
int | GetSplitterPosition (unsigned int splitterIndex=0) const
| Returns current splitter x position.
wxTextCtrl * | GetEditorTextCtrl () const
| Returns wxTextCtrl active in currently selected property, if any.
const wxPGCell & | GetUnspecifiedValueAppearance () const
| Returns current appearance of unspecified value cells.
wxString | GetUnspecifiedValueText (int argFlags=0) const
| Returns (visual) text representation of the unspecified property value.
int | GetVerticalSpacing () const
| Returns current vertical spacing.
wxPropertyGridHitTestResult | HitTest (const wxPoint &pt) const
| Returns information about arbitrary position in the grid.
bool | IsAnyModified () const
| Returns true if any property has been modified by the user.
bool | IsEditorFocused () const
| Returns true if a property editor control has focus.
bool | IsFrozen () const
| Returns true if updating is frozen (i.e.
void | MakeColumnEditable (unsigned int column, bool editable=true)
| Makes given column editable by user.
void | OnTLPChanging (wxWindow *newTLP)
| It is recommended that you call this function any time your code causes wxPropertyGrid's top-level parent to change.
void | RefreshEditor ()
| Refreshes any active editor control.
virtual void | RefreshProperty (wxPGProperty *p)
| Redraws given property.
void | ResetColours ()
| Resets all colours to the original system values.
void | ResetColumnSizes (bool enableAutoResizing=false)
| Resets column sizes and splitter positions, based on proportions.
bool | RemoveFromSelection (wxPGPropArg id)
| Removes given property from selection.
bool | SelectProperty (wxPGPropArg id, bool focus=false)
| Selects a property.
void | SetCaptionBackgroundColour (const wxColour &col)
| Sets category caption background colour.
void | SetCaptionTextColour (const wxColour &col)
| Sets category caption text colour.
void | SetCellBackgroundColour (const wxColour &col)
| Sets default cell background colour - applies to property cells.
void | SetCellDisabledTextColour (const wxColour &col)
| Sets cell text colour for disabled properties.
void | SetCellTextColour (const wxColour &col)
| Sets default cell text colour - applies to property name and value text.
void | SetColumnCount (int colCount)
| Set number of columns (2 or more).
void | SetCurrentCategory (wxPGPropArg id)
| Sets the 'current' category - Append will add non-category properties under it.
void | SetEmptySpaceColour (const wxColour &col)
| Sets colour of empty space below properties.
void | SetLineColour (const wxColour &col)
| Sets colour of lines between cells.
void | SetMarginColour (const wxColour &col)
| Sets background colour of margin.
void | SetSelection (const wxArrayPGProperty &newSelection)
| Set entire new selection from given list of properties.
void | SetSelectionBackgroundColour (const wxColour &col)
| Sets selection background colour - applies to selected property name background.
void | SetSelectionTextColour (const wxColour &col)
| Sets selection foreground colour - applies to selected property name text.
void | SetSortFunction (wxPGSortCallback sortFunction)
| Sets the property sorting function.
void | SetSplitterPosition (int newxpos, int col=0)
| Sets x coordinate of the splitter.
void | SetSplitterLeft (bool privateChildrenToo=false)
| Moves splitter as left as possible, while still allowing all labels to be shown in full.
void | SetUnspecifiedValueAppearance (const wxPGCell &cell)
| Sets appearance of value cells representing an unspecified property value.
void | SetVerticalSpacing (int vspacing)
| Sets vertical spacing.
void | SetVirtualWidth (int width)
| Set virtual width for this particular page.
void | SetupTextCtrlValue (const wxString &text)
| Must be called in wxPGEditor::CreateControls() if primary editor window is wxTextCtrl, just before textctrl is created.
bool | UnfocusEditor ()
| Unfocuses or closes editor if one was open, but does not deselect property.
void | DrawItemAndValueRelated (wxPGProperty *p)
| Draws item, children, and consecutive parents as long as category is not met.
wxPropertyGrid customization
Reimplement these member functions in derived class for better control over wxPropertyGrid behaviour.
virtual void | DoShowPropertyError (wxPGProperty *property, const wxString &msg)
| Override in derived class to display error messages in custom manner (these message usually only result from validation failure).
virtual void | DoHidePropertyError (wxPGProperty *property)
| Override in derived class to hide an error displayed by DoShowPropertyError().
virtual wxStatusBar * | GetStatusBar ()
| Return wxStatusBar that is used by this wxPropertyGrid.
virtual bool | DoOnValidationFailure (wxPGProperty *property, wxVariant &invalidValue)
| Override to customize property validation failure behaviour.
virtual void | DoOnValidationFailureReset (wxPGProperty *property)
| Override to customize resetting of property validation failure status.
Property development functions
These member functions are usually only called when creating custom user properties.
void | EditorsValueWasModified ()
| Call when editor widget's contents is modified.
void | EditorsValueWasNotModified ()
| Reverse of EditorsValueWasModified().
wxVariant | GetUncommittedPropertyValue ()
| Returns most up-to-date value of selected property.
bool | IsEditorsValueModified () const
| Returns true if editor's value was marked modified.
void | ShowPropertyError (wxPGPropArg id, const wxString &msg)
| Shows a brief error message that is related to a property.
void | ValueChangeInEvent (wxVariant variant)
| Call this from wxPGProperty::OnEvent() to cause property value to be changed after the function returns (with true as return value).
bool | WasValueChangedInEvent () const
| You can use this member function, for instance, to detect in wxPGProperty::OnEvent() if wxPGProperty::SetValueInEvent() was already called in wxPGEditor::OnEvent().
Public Member Functions inherited from wxScrolled< wxControl >
| wxScrolled ()
| Default constructor.
void | CalcScrolledPosition (int x, int y, int *xx, int *yy) const
| Translates the logical coordinates to the device ones.
void | CalcUnscrolledPosition (int x, int y, int *xx, int *yy) const
| Translates the device coordinates to the logical ones.
bool | Create (wxWindow *parent, wxWindowID id=-1, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxHSCROLL|wxVSCROLL, const wxString &name="scrolledWindow")
| Creates the window for two-step construction.
void | DisableKeyboardScrolling ()
| Disable use of keyboard keys for scrolling.
void | DoPrepareDC (wxDC &dc)
| Call this function to prepare the device context for drawing a scrolled image.
void | EnableScrolling (bool xScrolling, bool yScrolling)
| Enable or disable use of wxWindow::ScrollWindow() for scrolling.
void | ShowScrollbars (wxScrollbarVisibility horz, wxScrollbarVisibility vert)
| Set the scrollbar visibility.
void | GetScrollPixelsPerUnit (int *xUnit, int *yUnit) const
| Get the number of pixels per scroll unit (line), in each direction, as set by SetScrollbars().
void | GetViewStart (int *x, int *y) const
| Get the position at which the visible portion of the window starts.
void | GetVirtualSize (int *x, int *y) const
| Gets the size in device units of the scrollable window area (as opposed to the client size, which is the area of the window currently visible).
bool | IsRetained () const
| Motif only: true if the window has a backing bitmap.
virtual void | OnDraw (wxDC &dc)
| Called by the default paint event handler to allow the application to define painting behaviour without having to worry about calling DoPrepareDC().
void | PrepareDC (wxDC &dc)
| This function is for backwards compatibility only and simply calls DoPrepareDC() now.
void | Scroll (int x, int y)
| Scrolls a window so the view start is at the given point.
void | SetScrollRate (int xstep, int ystep)
| Set the horizontal and vertical scrolling increment only.
void | SetScrollbars (int pixelsPerUnitX, int pixelsPerUnitY, int noUnitsX, int noUnitsY, int xPos=0, int yPos=0, bool noRefresh=false)
| Sets up vertical and/or horizontal scrollbars.
void | SetTargetWindow (wxWindow *window)
| Call this function to tell wxScrolled to perform the actual scrolling on a different window (and not on itself).
wxWindow * | GetTargetWindow () const
void | SetTargetRect (const wxRect &rect)
wxRect | GetTargetRect () const
int | GetScrollPageSize (int orient) const
void | SetScrollPageSize (int orient, int pageSize)
int | GetScrollLines (int orient) const
void | SetScale (double xs, double ys)
double | GetScaleX () const
double | GetScaleY () const
virtual void | AdjustScrollbars ()
bool | IsAutoScrolling () const
| Are we generating the autoscroll events?
void | StopAutoScrolling ()
| Stop generating the scroll events when mouse is held outside the window.
virtual bool | SendAutoScrollEvents (wxScrollWinEvent &event) const
| This method can be overridden in a derived class to forbid sending the auto scroll events - note that unlike StopAutoScrolling() it doesn't stop the timer, so it will be called repeatedly and will typically return different values depending on the current mouse position.
Public Member Functions inherited from wxControl
| wxControl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
| Constructs a control.
| wxControl ()
| Default constructor to allow 2-phase creation.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
virtual void | Command (wxCommandEvent &event)
| Simulates the effect of the user issuing a command to the item.
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel().
wxString | GetLabelText () const
| Returns the control's label without mnemonics.
wxSize | GetSizeFromTextSize (int xlen, int ylen=-1) const
| Determine the size needed by the control to leave the given area for its text.
wxSize | GetSizeFromTextSize (const wxSize &tsize) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxSize | GetSizeFromText (const wxString &text) const
| Determine the minimum size needed by the control to display the given text.
void | SetLabel (const wxString &label)
| Sets the control's label.
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string.
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup.
Public Member Functions inherited from wxWindow
| wxWindow ()
| Default constructor.
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window.
virtual | ~wxWindow ()
| Destructor.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Construct the actual window object after creating the C++ object.
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus.
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard.
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus.
void | DisableFocusFromKeyboard ()
| Disable giving focus to this window using the keyboard navigation keys.
bool | IsFocusable () const
| Can this window itself have focus?
bool | CanAcceptFocus () const
| Can this window have focus right now?
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now?
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus.
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0).
virtual void | EnableVisibleFocus (bool enable)
| Enables or disables visible indication of keyboard focus.
virtual void | SetFocus ()
| This sets the window to receive keyboard input.
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. using `TAB` key).
virtual void | AddChild (wxWindow *child)
| Adds a child window.
bool | DestroyChildren ()
| Destroys all children of a window.
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id.
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name.
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children.
const wxWindowList & | GetChildren () const
| Returns a const reference to the list of the window's children.
virtual void | RemoveChild (wxWindow *child)
| Removes a child window.
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or NULL if there isn't one.
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or NULL if this window is the last child.
wxWindow * | GetParent () const
| Returns the parent of the window, or NULL if there is no parent.
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `NULL` if this window is the first child.
bool | IsDescendant (wxWindow *win) const
| Check if the specified window is a descendant of this one.
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g.
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling.
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position.
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range.
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size.
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation.
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation.
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown.
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up.
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up.
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=NULL)
| Physically scrolls the pixels in the window and move child windows accordingly.
bool | LineUp ()
| Same as ScrollLines (-1).
bool | LineDown ()
| Same as ScrollLines (1).
bool | PageUp ()
| Same as ScrollPages (-1).
bool | PageDown ()
| Same as ScrollPages (1).
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars.
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar.
void | Center (int dir=wxBOTH)
| A synonym for Centre().
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent().
void | Centre (int direction=wxBOTH)
| Centres the window.
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent.
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object.
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object.
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...).
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates.
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | SetPosition (const wxPoint &pt)
| Moves the window to the specified position.
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels.
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units.
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates.
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates.
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour.
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all.
void | Thaw ()
| Re-enables window updating after a previous call to Freeze().
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze().
wxColour | GetBackgroundColour () const
| Returns the background colour of the window.
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window.
virtual int | GetCharHeight () const
| Returns the character height for this window.
virtual int | GetCharWidth () const
| Returns the average character width for this window.
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()).
virtual wxSize | GetDPI () const
| Return the DPI of the display used by this window.
wxFont | GetFont () const
| Returns the font for this window.
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window.
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=NULL, int *externalLeading=NULL, const wxFont *font=NULL) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged.
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords.
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background.
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=NULL)
| Causes this window, and all of its children recursively, to be repainted.
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted.
virtual void | Update ()
| Immediately repaints the invalidated area of the window and all of its children recursively.
virtual bool | SetBackgroundColour (const wxColour &colour)
| Sets the background colour of the window.
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window.
virtual bool | IsTransparentBackgroundSupported (wxString *reason=NULL) const
| Checks whether using transparent background might work.
virtual bool | SetFont (const wxFont &font)
| Sets the font for this window.
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window.
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window.
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent.
bool | UseBgCol () const
| Return true if a background colour has been set for this window.
bool | UseBackgroundColour () const
| Return true if a background colour has been set for this window.
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window.
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window.
bool | UseForegroundColour () const
| Return true if a foreground colour has been set for this window.
bool | InheritsForegroundColour () const
| Return true if this window inherits the foreground colour from its parent.
void | SetPalette (const wxPalette &pal)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes().
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code.
virtual bool | GetThemeEnabled () const
| Returns true if the window uses the system theme for drawing its background.
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed.
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window.
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window.
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case.
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for:
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent().
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally().
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack.
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window.
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack.
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window.
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
long | GetExtraStyle () const
| Returns the extra style bits for the window.
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method.
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info.
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles.
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set.
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window.
virtual void | SetWindowStyleFlag (long style)
| Sets the style of the window.
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info.
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa.
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win.
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it.
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window.
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window.
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order).
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order).
bool | Hide ()
| Equivalent to calling wxWindow::Show(false).
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible.
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise.
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint.
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden.
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well.
bool | Disable ()
| Disables the window.
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input.
virtual bool | Show (bool show=true)
| Shows or hides the window.
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible.
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window.
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window.
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window.
wxToolTip * | GetToolTip () const
| Get the associated tooltip or NULL if none.
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none.
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window.
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | UnsetToolTip ()
| Unset any existing tooltip.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu.
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxValidator * | GetValidator ()
| Validator functions.
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type.
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators.
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators.
virtual bool | Validate ()
| Validates the current values of the child controls using their validators.
wxWindowID | GetId () const
| Returns the identifier of the window.
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported.
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32.
virtual wxString | GetName () const
| Returns the window's name.
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant().
void | SetId (wxWindowID winid)
| Sets the identifier of the window.
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window.
virtual void | SetName (const wxString &name)
| Sets the window's name.
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use.
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window.
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any.
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window.
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window.
virtual wxAccessible * | CreateAccessible ()
| Override to create a specific accessible object.
wxAccessible * | GetOrCreateAccessible ()
| Returns the accessible object, calling CreateAccessible if necessary.
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window.
virtual bool | Destroy ()
| Destroys the window safely.
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed.
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be NULL.
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window.
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles).
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise NULL.
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or NULL.
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer.
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| Associate the sizer with the window and set the window size and minimal size accordingly.
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or NULL if there are none.
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints.
virtual bool | Layout ()
| Lays out the children of this window using the associated sizer.
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized.
bool | GetAutoLayout () const
| Returns true if Layout() is called automatically when the window is resized.
void | CaptureMouse ()
| Directs all mouse input to this window.
wxCaret * | GetCaret () const
| Returns the caret() associated with the window.
const wxCursor & | GetCursor () const
| Return the cursor associated with this window.
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture.
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse().
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window.
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor.
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window.
virtual bool | EnableTouchEvents (int eventsMask)
| Request generation of touch events for this window.
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Return where the given point lies, exactly.
wxHitTest | HitTest (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.
wxBorder | GetBorder () const
| Get border for the flags of this window.
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event.
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window.
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages.
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours.
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators.
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later.
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it.
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called.
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one.
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class.
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows.
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey.
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey.
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window.
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows.
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once.
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value.
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size.
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size.
virtual void | Fit ()
| Sizes the window to fit its best size.
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window.
wxSize | FromDIP (const wxSize &sz) const
| Convert DPI-independent pixel values to the value in pixels appropriate for the current toolkit.
wxPoint | FromDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | FromDIP (int d) const
| Convert DPI-independent distance in pixels to the value in pixels appropriate for the current toolkit.
wxSize | ToDIP (const wxSize &sz) const
| Convert pixel values of the current toolkit to DPI-independent pixel values.
wxPoint | ToDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | ToDIP (int d) const
| Convert pixel values of the current toolkit to DPI-independent pixel values.
wxSize | FromPhys (const wxSize &sz) const
| Convert from physical pixels to logical pixels.
wxPoint | FromPhys (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | FromPhys (int d) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxSize | ToPhys (const wxSize &sz) const
| Convert from logical pixels to physical pixels.
wxPoint | ToPhys (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | ToPhys (int d) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window.
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width.
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height.
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels.
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result.
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area.
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window.
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area.
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size.
int | GetMinWidth () const
| Returns the horizontal component of window minimal size.
int | GetMinHeight () const
| Returns the vertical component of window minimal size.
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size.
int | GetMaxHeight () const
| Returns the vertical component of window maximal size.
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc.
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info.
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels.
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead.
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means).
double | GetContentScaleFactor () const
| Returns the factor mapping logical pixels of this window to physical pixels.
double | GetDPIScaleFactor () const
| Returns the ratio of the DPI used by this window to the standard DPI.
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively.
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known.
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed.
void | PostSizeEvent ()
| Posts a size event to the window.
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window.
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions.
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent().
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels.
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetContainingSizer (wxSizer *sizer)
| Used by wxSizer internally to notify the window about being managed by the given sizer.
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values.
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area.
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size.
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area.
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size.
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels.
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels.
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged.
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels.
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor.
virtual | ~wxEvtHandler ()
| Destructor.
template<typename T, typename T1, ...>
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method.
template<typename T>
void | CallAfter (const T &functor)
| Asynchronously call the given functor.
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it.
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process.
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail.
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent().
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type.
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
template<typename EventTag, typename Functor>
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event.
template<typename EventTag, typename Class, typename EventArg, typename EventHandler>
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
template<typename EventTag, typename Functor>
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
template<typename EventTag, typename Class, typename EventArg, typename EventHandler>
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
void * | GetClientData () const
| Returns user-supplied client data.
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object.
void | SetClientData (void *data)
| Sets user-supplied client data.
void | SetClientObject (wxClientData *data)
| Set the client data object.
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise.
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain.
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain.
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler.
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted).
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
Public Member Functions inherited from wxPropertyGridInterface
virtual | ~wxPropertyGridInterface ()
| Destructor.
wxPGProperty * | Append (wxPGProperty *property)
| Appends property to the list.
wxPGProperty * | AppendIn (wxPGPropArg id, wxPGProperty *newProperty)
| Same as Append(), but appends under given parent property.
void | BeginAddChildren (wxPGPropArg id)
| In order to add new items into a property with private children (for instance, wxFlagsProperty), you need to call this method.
bool | ClearSelection (bool validation=false)
| Clears current selection, if any.
void | ClearModifiedStatus ()
| Resets modified status of all properties.
bool | Collapse (wxPGPropArg id)
| Collapses given category or property with children.
bool | CollapseAll ()
| Collapses all items that can be collapsed.
bool | ChangePropertyValue (wxPGPropArg id, wxVariant newValue)
| Changes value of a property, as if by user.
void | DeleteProperty (wxPGPropArg id)
| Removes and deletes a property and any children.
bool | DisableProperty (wxPGPropArg id)
| Disables a property.
bool | EditorValidate ()
| Returns true if all property grid data changes have been committed.
bool | EnableProperty (wxPGPropArg id, bool enable=true)
| Enables or disables property.
void | EndAddChildren (wxPGPropArg id)
| Called after population of property with fixed children has finished.
bool | Expand (wxPGPropArg id)
| Expands given category or property with children.
bool | ExpandAll (bool expand=true)
| Expands all items that can be expanded.
int | GetColumnProportion (unsigned int column) const
| Returns auto-resize proportion of the given column.
wxPGProperty * | GetFirstChild (wxPGPropArg id)
| Returns id of first child of given property.
wxPropertyGridIterator | GetIterator (int flags=wxPG_ITERATE_DEFAULT, wxPGProperty *firstProp=NULL)
| Returns iterator class instance.
wxPropertyGridConstIterator | GetIterator (int flags=wxPG_ITERATE_DEFAULT, wxPGProperty *firstProp=NULL) const
wxPropertyGridIterator | GetIterator (int flags, int startPos)
| Returns iterator class instance.
wxPropertyGridConstIterator | GetIterator (int flags, int startPos) const
wxPGProperty * | GetFirst (int flags=wxPG_ITERATE_ALL)
| Returns id of first item that matches given criteria.
const wxPGProperty * | GetFirst (int flags=wxPG_ITERATE_ALL) const
wxPGProperty * | GetProperty (const wxString &name) const
| Returns pointer to a property with given name (case-sensitive).
void | GetPropertiesWithFlag (wxArrayPGProperty *targetArr, wxPGProperty::FlagType flags, bool inverse=false, int iterFlags=(wxPG_ITERATE_PROPERTIES|wxPG_ITERATE_HIDDEN|wxPG_ITERATE_CATEGORIES)) const
| Adds to targetArr pointers to properties that have given flags set.
wxVariant | GetPropertyAttribute (wxPGPropArg id, const wxString &attrName) const
| Returns value of given attribute.
const wxPGAttributeStorage & | GetPropertyAttributes (wxPGPropArg id) const
| Returns map-like storage of property's attributes.
wxColour | GetPropertyBackgroundColour (wxPGPropArg id) const
| Returns background colour of first cell of a property.
wxPropertyCategory * | GetPropertyCategory (wxPGPropArg id) const
| Returns pointer of property's nearest parent category.
void * | GetPropertyClientData (wxPGPropArg id) const
| Returns client data (void*) of a property.
wxPGProperty * | GetPropertyByLabel (const wxString &label) const
| Returns first property which label matches given string.
wxPGProperty * | GetPropertyByName (const wxString &name) const
| Returns pointer to a property with given name (case-sensitive).
wxPGProperty * | GetPropertyByName (const wxString &name, const wxString &subname) const
| Returns child property subname of property name.
const wxPGEditor * | GetPropertyEditor (wxPGPropArg id) const
| Returns property's editor.
wxString | GetPropertyHelpString (wxPGPropArg id) const
| Returns help string associated with a property.
wxBitmap * | GetPropertyImage (wxPGPropArg id) const
| Returns property's custom value image (NULL of none).
const wxString & | GetPropertyLabel (wxPGPropArg id)
| Returns label of a property.
wxString | GetPropertyName (wxPGProperty *property)
| Returns property's name, by which it is globally accessible.
wxPGProperty * | GetPropertyParent (wxPGPropArg id)
| Returns parent item of a property.
wxColour | GetPropertyTextColour (wxPGPropArg id) const
| Returns text colour of first cell of a property.
wxValidator * | GetPropertyValidator (wxPGPropArg id)
| Returns validator of a property as a reference, which you can pass to any number of SetPropertyValidator.
wxVariant | GetPropertyValue (wxPGPropArg id)
| Returns property's value as wxVariant.
wxArrayInt | GetPropertyValueAsArrayInt (wxPGPropArg id) const
| Return's property's value as wxArrayInt.
wxArrayString | GetPropertyValueAsArrayString (wxPGPropArg id) const
| Returns property's value as wxArrayString.
bool | GetPropertyValueAsBool (wxPGPropArg id) const
| Returns property's value as bool.
wxDateTime | GetPropertyValueAsDateTime (wxPGPropArg id) const
| Return's property's value as wxDateTime.
double | GetPropertyValueAsDouble (wxPGPropArg id) const
| Returns property's value as double-precision floating point number.
int | GetPropertyValueAsInt (wxPGPropArg id) const
| Returns property's value as integer.
long | GetPropertyValueAsLong (wxPGPropArg id) const
| Returns property's value as integer.
wxLongLong_t | GetPropertyValueAsLongLong (wxPGPropArg id) const
| Returns property's value as native signed 64-bit integer.
wxString | GetPropertyValueAsString (wxPGPropArg id) const
| Returns property's value as wxString.
unsigned long | GetPropertyValueAsULong (wxPGPropArg id) const
| Returns property's value as unsigned integer.
wxULongLong_t | GetPropertyValueAsULongLong (wxPGPropArg id) const
| Returns property's value as native unsigned 64-bit integer.
wxVariant | GetPropertyValues (const wxString &listname=wxEmptyString, wxPGProperty *baseparent=NULL, long flags=0) const
| Returns a wxVariant list containing wxVariant versions of all property values.
const wxArrayPGProperty & | GetSelectedProperties () const
| Returns list of currently selected properties.
wxPGProperty * | GetSelection () const
| Returns currently selected property.
virtual wxPGVIterator | GetVIterator (int flags) const
| Similar to GetIterator(), but instead returns wxPGVIterator instance, which can be useful for forward-iterating through arbitrary property containers.
bool | HideProperty (wxPGPropArg id, bool hide=true, int flags=wxPG_RECURSE)
| Hides or reveals a property.
wxPGProperty * | Insert (wxPGPropArg priorThis, wxPGProperty *newProperty)
| Inserts property to the property container.
wxPGProperty * | Insert (wxPGPropArg parent, int index, wxPGProperty *newProperty)
| Inserts property to the property container.
bool | IsPropertyCategory (wxPGPropArg id) const
| Returns true if property is a category.
bool | IsPropertyEnabled (wxPGPropArg id) const
| Returns true if property is enabled.
bool | IsPropertyExpanded (wxPGPropArg id) const
| Returns true if given property is expanded.
bool | IsPropertyModified (wxPGPropArg id) const
| Returns true if property has been modified after value set or modify flag clear by software.
bool | IsPropertySelected (wxPGPropArg id) const
| Returns true if property is selected.
bool | IsPropertyShown (wxPGPropArg id) const
| Returns true if property is shown (i.e.
bool | IsPropertyValueUnspecified (wxPGPropArg id) const
| Returns true if property value is set to unspecified.
void | LimitPropertyEditing (wxPGPropArg id, bool limit=true)
| Disables (limit = true) or enables (limit = false) wxTextCtrl editor of a property, if it is not the sole mean to edit the value.
virtual void | RefreshGrid (wxPropertyGridPageState *state=NULL)
| If state is shown in its grid, refresh it now.
wxPGProperty * | RemoveProperty (wxPGPropArg id)
| Removes a property.
wxPGProperty * | ReplaceProperty (wxPGPropArg id, wxPGProperty *property)
| Replaces property with id with newly created one.
bool | RestoreEditableState (const wxString &src, int restoreStates=AllStates)
| Restores user-editable state.
wxString | SaveEditableState (int includedStates=AllStates) const
| Used to acquire user-editable state (selected property, expanded properties, scrolled position, splitter positions).
bool | SetColumnProportion (unsigned int column, int proportion)
| Set proportion of an auto-stretchable column.
void | SetPropertyAttribute (wxPGPropArg id, const wxString &attrName, wxVariant value, long argFlags=0)
| Sets an attribute for this property.
void | SetPropertyAttributeAll (const wxString &attrName, wxVariant value)
| Sets property attribute for all applicable properties.
void | SetPropertyBackgroundColour (wxPGPropArg id, const wxColour &colour, int flags=wxPG_RECURSE)
| Sets background colour of given property.
void | SetPropertyCell (wxPGPropArg id, int column, const wxString &text=wxEmptyString, const wxBitmapBundle &bitmap=wxBitmapBundle(), const wxColour &fgCol=wxNullColour, const wxColour &bgCol=wxNullColour)
| Sets text, bitmap, and colours for given column's cell.
void | SetPropertyClientData (wxPGPropArg id, void *clientData)
| Sets client data (void*) of a property.
void | SetPropertyColoursToDefault (wxPGPropArg id, int flags=wxPG_DONT_RECURSE)
| Resets text and background colours of given property.
void | SetPropertyEditor (wxPGPropArg id, const wxPGEditor *editor)
| Sets editor for a property.
void | SetPropertyEditor (wxPGPropArg id, const wxString &editorName)
| Sets editor control of a property.
void | SetPropertyLabel (wxPGPropArg id, const wxString &newproplabel)
| Sets label of a property.
void | SetPropertyName (wxPGPropArg id, const wxString &newName)
| Sets name of a property.
void | SetPropertyReadOnly (wxPGPropArg id, bool set=true, int flags=wxPG_RECURSE)
| Sets property (and, recursively, its children) to have read-only value.
void | SetPropertyValueUnspecified (wxPGPropArg id)
| Sets property's value to unspecified.
void | SetPropertyValues (const wxVariantList &list, wxPGPropArg defaultCategory=wxNullProperty)
| Sets property values from a list of wxVariants.
void | SetPropertyValues (const wxVariant &list, wxPGPropArg defaultCategory=wxNullProperty)
| Sets property values from a list of wxVariants.
void | SetPropertyHelpString (wxPGPropArg id, const wxString &helpString)
| Associates the help string with property.
void | SetPropertyImage (wxPGPropArg id, wxBitmapBundle &bmp)
| Set wxBitmap taken from wxBitmapBundle in front of the value.
bool | SetPropertyMaxLength (wxPGPropArg id, int maxLen)
| Sets maximum length of text in property text editor.
void | SetPropertyTextColour (wxPGPropArg id, const wxColour &colour, int flags=wxPG_RECURSE)
| Sets text colour of given property.
void | SetPropertyValidator (wxPGPropArg id, const wxValidator &validator)
| Sets validator of a property.
void | SetPropertyValue (wxPGPropArg id, long value)
| Sets value (long integer) of a property.
void | SetPropertyValue (wxPGPropArg id, int value)
| Sets value (integer) of a property.
void | SetPropertyValue (wxPGPropArg id, double value)
| Sets value (floating point) of a property.
void | SetPropertyValue (wxPGPropArg id, bool value)
| Sets value (bool) of a property.
void | SetPropertyValue (wxPGPropArg id, const wchar_t *value)
| Sets value (wchar_t*) of a property.
void | SetPropertyValue (wxPGPropArg id, const char *value)
| Sets value (char*) of a property.
void | SetPropertyValue (wxPGPropArg id, const wxString &value)
| Sets value (string) of a property.
void | SetPropertyValue (wxPGPropArg id, const wxArrayString &value)
| Sets value (wxArrayString) of a property.
void | SetPropertyValue (wxPGPropArg id, const wxDateTime &value)
| Sets value (wxDateTime) of a property.
void | SetPropertyValue (wxPGPropArg id, wxObject *value)
| Sets value (wxObject*) of a property.
void | SetPropertyValue (wxPGPropArg id, wxObject &value)
| Sets value (wxObject&) of a property.
void | SetPropertyValue (wxPGPropArg id, wxLongLong_t value)
| Sets value (native 64-bit int) of a property.
void | SetPropertyValue (wxPGPropArg id, wxLongLong value)
| Sets value (wxLongLong) of a property.
void | SetPropertyValue (wxPGPropArg id, wxULongLong_t value)
| Sets value (native 64-bit unsigned int) of a property.
void | SetPropertyValue (wxPGPropArg id, wxULongLong value)
| Sets value (wxULongLong) of a property.
void | SetPropertyValue (wxPGPropArg id, const wxArrayInt &value)
| Sets value (wxArrayInt&) of a property.
void | SetPropertyValueString (wxPGPropArg id, const wxString &value)
| Sets value (wxString) of a property.
void | SetPropertyValue (wxPGPropArg id, wxVariant value)
| Sets value (wxVariant) of a property.
void | SetPropVal (wxPGPropArg id, wxVariant &value)
| Sets value (wxVariant&) of a property.
void | SetValidationFailureBehavior (int vfbFlags)
| Adjusts how wxPropertyGrid behaves when invalid value is entered in a property.
void | Sort (int flags=0)
| Sorts all properties recursively.
void | SortChildren (wxPGPropArg id, int flags=0)
| Sorts children of a property.
wxPGProperty * | GetPropertyByNameA (const wxString &name) const
| GetPropertyByName() with assertion error message.

## Static Public Member Functions
static void | AutoGetTranslation (bool enable)
| This static function enables or disables automatic use of wxGetTranslation() for following strings: wxEnumProperty list labels, wxFlagsProperty child property labels.
static wxPGEditor * | RegisterEditorClass (wxPGEditor *editor, bool noDefCheck=false)
| Forwards to DoRegisterEditorClass with empty name.
static wxPGEditor * | DoRegisterEditorClass (wxPGEditor *editor, const wxString &name, bool noDefCheck=false)
| Registers a new editor class.
Static Public Member Functions inherited from wxControl
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters).
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters).
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string.
static wxString | Ellipsize (const wxString &label, const wxDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible.
Static Public Member Functions inherited from wxWindow
static wxVisualAttributes | GetClassDefaultAttributes (wxWindowVariant variant=wxWINDOW_VARIANT_NORMAL)
| Returns the default font and colours which are used by the control.
static wxWindow * | FindFocus ()
| Finds the window or control which currently has the keyboard focus.
static wxWindow * | FindWindowById (long id, const wxWindow *parent=0)
| Find the first window with the given id.
static wxWindow * | FindWindowByLabel (const wxString &label, const wxWindow *parent=0)
| Find a window by its label.
static wxWindow * | FindWindowByName (const wxString &name, const wxWindow *parent=0)
| Find a window by its name (as given in a window constructor or Create() function call).
static wxWindow * | GetCapture ()
| Returns the currently captured window.
static wxWindowID | NewControlId (int count=1)
| Create a new ID or range of IDs that are not currently in use.
static void | UnreserveControlId (wxWindowID id, int count=1)
| Unreserve an ID or range of IDs that was reserved by NewControlId().
static wxSize | FromDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific DPI-independent pixels conversion functions.
static wxPoint | FromDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | FromDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxSize | ToDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific pixel to DPI-independent pixels conversion functions.
static wxPoint | ToDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | ToDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxSize | FromPhys (const wxSize &sz, const wxWindow *w)
| Convert from physical pixels to logical pixels for any window.
static wxPoint | FromPhys (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | FromPhys (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxSize | ToPhys (const wxSize &sz, const wxWindow *w)
| Convert from logical pixels to physical pixels for any window.
static wxPoint | ToPhys (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | ToPhys (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Static Public Member Functions inherited from wxEvtHandler
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets.
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter().
Static Public Member Functions inherited from wxPropertyGridInterface
static void | InitAllTypeHandlers ()
| Initializes all property types.
static void | RegisterAdditionalEditors ()
| Initializes additional property editors (SpinCtrl etc.).
static void | SetBoolChoices (const wxString &trueChoice, const wxString &falseChoice)
| Sets strings listed in the choice dropdown of a wxBoolProperty.
static wxPGEditor * | GetEditorByName (const wxString &editorName)
| Returns editor pointer of editor with given name.

## Additional Inherited Members
Public Types inherited from wxPropertyGridInterface
enum | EditableStateFlags { SelectionState , ExpandedState , ScrollPosState , PageState , SplitterPosState , DescBoxState , AllStates }
| More...
Protected Member Functions inherited from wxScrolled< wxControl >
virtual bool | ShouldScrollToChildOnFocus (wxWindow *child)
| This method can be overridden in a derived class to prevent scrolling the child window into view automatically when it gets focus.
virtual wxSize | GetSizeAvailableForScrollTarget (const wxSize &size)
| Function which must be overridden to implement the size available for the scroll target for the given size of the main window.
Protected Member Functions inherited from wxWindow
virtual void | DoCentre (int direction)
| Centres the window.
virtual wxSize | DoGetBestSize () const
| Implementation of GetBestSize() that can be overridden.
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control.
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation.
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation.
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord).
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window.
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself.
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
virtual void | QueueEvent (wxEvent *event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
virtual void | AddPendingEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
void | ProcessPendingEvents ()
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
bool | ProcessThreadEvent (const wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables.
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort.
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

## ◆ wxPropertyGrid() [1/2]

wxPropertyGrid::wxPropertyGrid | ( |  | ) |

Two step constructor.

Call Create() when this constructor is called to build up the wxPropertyGrid

## ◆ wxPropertyGrid() [2/2]

wxPropertyGrid::wxPropertyGrid | ( | wxWindow * | parent,
|  | wxWindowID | id = wxID_ANY,
|  | const wxPoint & | pos = wxDefaultPosition,
|  | const wxSize & | size = wxDefaultSize,
|  | long | style = wxPG_DEFAULT_STYLE,
|  | const wxString & | name = wxPropertyGridNameStr )

Constructor.

The styles to be used are styles valid for the wxWindow.

See also
  wxPropertyGrid Window Styles.

## ◆ ~wxPropertyGrid()

virtual wxPropertyGrid::~wxPropertyGrid | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ AddActionTrigger()

void wxPropertyGrid::AddActionTrigger | ( | int | action,
|  | int | keycode,
|  | int | modifiers = 0 )

Adds given key combination to trigger given action.

Here is a sample code to make Enter key press move focus to the next property.

propGrid->AddActionTrigger(wxPG_ACTION_NEXT_PROPERTY,
WXK_RETURN);
propGrid->DedicateKey(WXK_RETURN);
WXK_RETURN
@ WXK_RETURN
Definition defs.h:914
wxPG_ACTION_NEXT_PROPERTY
@ wxPG_ACTION_NEXT_PROPERTY
Select the next property.
Definition propgrid.h:400

Parameters

  action | Which action to trigger. See wxPropertyGrid Action Identifiers.
  keycode | Which keycode triggers the action.
  modifiers | Which key event modifiers, in addition to keycode, are needed to trigger the action.

## ◆ AddToSelection()

bool wxPropertyGrid::AddToSelection | ( | wxPGPropArg | id | ) |

Adds given property into selection.

If wxPG_EX_MULTIPLE_SELECTION extra style is not used, then this has same effect as calling SelectProperty().

Remarks
  Multiple selection is not supported for categories. This means that if you have properties selected, you cannot add category to selection, and also if you have category selected, you cannot add other properties to selection. This member function will fail silently in these cases, even returning true.

## ◆ AutoGetTranslation()

void wxPropertyGrid::AutoGetTranslation | ( | bool | enable | ) |
| static

This static function enables or disables automatic use of wxGetTranslation() for following strings: wxEnumProperty list labels, wxFlagsProperty child property labels.

Default is false.

## ◆ BeginLabelEdit()

void wxPropertyGrid::BeginLabelEdit | ( | unsigned int | colIndex = 0 | ) |

Creates label editor wxTextCtrl for given column, for property that is currently selected.

When multiple selection is enabled, this applies to whatever property GetSelection() returns.

Parameters

  colIndex | Which column's label to edit. Note that you should not use value 1, which is reserved for property value column.

See also
  EndLabelEdit(), MakeColumnEditable()

## ◆ CenterSplitter()

void wxPropertyGrid::CenterSplitter | ( | bool | enableAutoResizing = false | ) |

Centers the splitter.

Parameters

  enableAutoResizing | If true, automatic column resizing is enabled (only applicable if window style wxPG_SPLITTER_AUTO_CENTER is used).

## ◆ ChangePropertyValue()

bool wxPropertyGrid::ChangePropertyValue | ( | wxPGPropArg | id,
|  | wxVariant | newValue )

Changes value of a property, as if from an editor.

Use this instead of SetPropertyValue() if you need the value to run through validation process, and also send `wxEVT_PG_CHANGED`.

Remarks
  Since this function sends `wxEVT_PG_CHANGED`, it should not be called from `EVT_PG_CHANGED` handler.

Returns
  Returns true if value was successfully changed.

## ◆ Clear()

virtual void wxPropertyGrid::Clear | ( |  | ) |
| virtual

Deletes all properties.

Implements wxPropertyGridInterface.

## ◆ ClearActionTriggers()

void wxPropertyGrid::ClearActionTriggers | ( | int | action | ) |

Clears action triggers for given action.

Parameters

  action | Which action to trigger. wxPropertyGrid Action Identifiers.

## ◆ CommitChangesFromEditor()

virtual bool wxPropertyGrid::CommitChangesFromEditor | ( | wxUint32 | flags = 0 | ) |
| virtual

Forces updating the value of property from the editor control.

Note that `wxEVT_PG_CHANGING` and `wxEVT_PG_CHANGED` are dispatched using ProcessEvent, meaning your event handlers will be called immediately.

Returns
  Returns true if anything was changed.

## ◆ Create()

bool wxPropertyGrid::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = wxID_ANY,
|  | const wxPoint & | pos = wxDefaultPosition,
|  | const wxSize & | size = wxDefaultSize,
|  | long | style = wxPG_DEFAULT_STYLE,
|  | const wxString & | name = wxPropertyGridNameStr )

Two step creation.

Whenever the control is created without any parameters, use Create to actually create it. Don't access the control's public methods before this is called

See also
  wxPropertyGrid Window Styles.

## ◆ DedicateKey()

void wxPropertyGrid::DedicateKey | ( | int | keycode | ) |

Dedicates a specific keycode to wxPropertyGrid.

This means that such key presses will not be redirected to editor controls.

Using this function allows, for example, navigation between properties using arrow keys even when the focus is in the editor control.

## ◆ DoHidePropertyError()

virtual void wxPropertyGrid::DoHidePropertyError | ( | wxPGProperty * | property | ) |
| virtual

Override in derived class to hide an error displayed by DoShowPropertyError().

See also
  DoShowPropertyError()

## ◆ DoOnValidationFailure()

virtual bool wxPropertyGrid::DoOnValidationFailure | ( | wxPGProperty * | property,
|  | wxVariant & | invalidValue )
| virtual

Override to customize property validation failure behaviour.

Parameters

  property | Property with entered an invalid value
  invalidValue | Value which failed in validation.

Returns
  Return true if user is allowed to change to another property even if current has invalid value.

## ◆ DoOnValidationFailureReset()

virtual void wxPropertyGrid::DoOnValidationFailureReset | ( | wxPGProperty * | property | ) |
| virtual

Override to customize resetting of property validation failure status.

Remarks
  Property is guaranteed to have flag wxPG_PROP_INVALID_VALUE set.

## ◆ DoRegisterEditorClass()

wxPGEditor * wxPropertyGrid::DoRegisterEditorClass | ( | wxPGEditor * | editor,
|  | const wxString & | name,
|  | bool | noDefCheck = false )
| static

Registers a new editor class.

Returns
  Returns pointer to the editor class instance that should be used.

## ◆ DoShowPropertyError()

virtual void wxPropertyGrid::DoShowPropertyError | ( | wxPGProperty * | property,
|  | const wxString & | msg )
| virtual

Override in derived class to display error messages in custom manner (these message usually only result from validation failure).

Remarks
  If you implement this, then you also need to implement DoHidePropertyError() - possibly to do nothing, if error does not need hiding (e.g. it was logged or shown in a message box).

See also
  DoHidePropertyError()

## ◆ DrawItemAndValueRelated()

void wxPropertyGrid::DrawItemAndValueRelated | ( | wxPGProperty * | p | ) |

Draws item, children, and consecutive parents as long as category is not met.

## ◆ EditorsValueWasModified()

void wxPropertyGrid::EditorsValueWasModified | ( |  | ) |

Call when editor widget's contents is modified.

For example, this is called when changes text in wxTextCtrl (used in wxStringProperty and wxIntProperty).

Remarks
  This function should only be called by custom properties.

See also
  wxPGProperty::OnEvent()

## ◆ EditorsValueWasNotModified()

void wxPropertyGrid::EditorsValueWasNotModified | ( |  | ) |

Reverse of EditorsValueWasModified().

Remarks
  This function should only be called by custom properties.

## ◆ EnableCategories()

bool wxPropertyGrid::EnableCategories | ( | bool | enable | ) |

Enables or disables (shows/hides) categories according to parameter enable.

Remarks
  This functions deselects selected property, if any. Validation failure option wxPG_VFB_STAY_IN_PROPERTY is not respected, i.e. selection is cleared even if editor had invalid value.

## ◆ EndLabelEdit()

void wxPropertyGrid::EndLabelEdit | ( | bool | commit = true | ) |

Destroys label editor wxTextCtrl, if any.

Parameters

  commit | Use true (default) to store edited label text in property cell data.

See also
  BeginLabelEdit(), MakeColumnEditable()

## ◆ EnsureVisible()

bool wxPropertyGrid::EnsureVisible | ( | wxPGPropArg | id | ) |

Scrolls and/or expands items to ensure that the given item is visible.

Returns
  Returns true if something was actually done.

## ◆ FitColumns()

wxSize wxPropertyGrid::FitColumns | ( |  | ) |

Reduces column sizes to minimum possible, while still retaining fully visible grid contents (labels, images).

Returns
  Minimum size for the grid to still display everything.

Remarks
  Does not work well with wxPG_SPLITTER_AUTO_CENTER window style.

          This function only works properly if grid size prior to call was
          already fairly large.

          Note that you can also get calculated column widths by calling
          GetState->GetColumnWidth() immediately after this function
          returns.

## ◆ GetCaptionBackgroundColour()

wxColour wxPropertyGrid::GetCaptionBackgroundColour | ( |  | ) | const

Returns current category caption background colour.

## ◆ GetCaptionFont()

wxFont & wxPropertyGrid::GetCaptionFont | ( |  | ) |

Returns current category caption font.

## ◆ GetCaptionForegroundColour()

wxColour wxPropertyGrid::GetCaptionForegroundColour | ( |  | ) | const

Returns current category caption text colour.

## ◆ GetCellBackgroundColour()

wxColour wxPropertyGrid::GetCellBackgroundColour | ( |  | ) | const

Returns current cell background colour.

## ◆ GetCellDisabledTextColour()

wxColour wxPropertyGrid::GetCellDisabledTextColour | ( |  | ) | const

Returns current cell text colour when disabled.

## ◆ GetCellTextColour()

wxColour wxPropertyGrid::GetCellTextColour | ( |  | ) | const

Returns current cell text colour.

## ◆ GetColumnCount()

unsigned int wxPropertyGrid::GetColumnCount | ( |  | ) | const

Returns number of columns currently on grid.

## ◆ GetEditorTextCtrl()

wxTextCtrl * wxPropertyGrid::GetEditorTextCtrl | ( |  | ) | const

Returns wxTextCtrl active in currently selected property, if any.

Takes wxOwnerDrawnComboBox into account.

## ◆ GetEmptySpaceColour()

wxColour wxPropertyGrid::GetEmptySpaceColour | ( |  | ) | const

Returns colour of empty space below properties.

## ◆ GetFontHeight()

int wxPropertyGrid::GetFontHeight | ( |  | ) | const

Returns height of highest characters of used font.

## ◆ GetGrid()

wxPropertyGrid * wxPropertyGrid::GetGrid | ( |  | ) |

Returns pointer to itself.

Dummy function that enables same kind of code to use wxPropertyGrid and wxPropertyGridManager.

## ◆ GetImageRect()

wxRect wxPropertyGrid::GetImageRect | ( | wxPGProperty * | property,
|  | int | item ) const

Returns rectangle of custom paint image.

Parameters

  property | Return image rectangle for this property.
  item | Which choice of property to use (each choice may have different image).

## ◆ GetImageSize()

wxSize wxPropertyGrid::GetImageSize | ( | wxPGProperty * | property = NULL,
|  | int | item = -1 ) const

Returns size of the custom paint image in front of property.

Parameters

  property | Return image rectangle for this property. If this argument is NULL, then preferred size is returned.
  item | Which choice of property to use (each choice may have different image).

## ◆ GetLabelEditor()

wxTextCtrl * wxPropertyGrid::GetLabelEditor | ( |  | ) | const

Returns currently active label editor, NULL if none.

## ◆ GetLastItem()

wxPGProperty * wxPropertyGrid::GetLastItem | ( | int | flags = wxPG_ITERATE_DEFAULT | ) |

Returns last item which could be iterated using given flags.

Parameters

  flags | See wxPropertyGridIterator Flags.

## ◆ GetLineColour()

wxColour wxPropertyGrid::GetLineColour | ( |  | ) | const

Returns colour of lines between cells.

## ◆ GetMarginColour()

wxColour wxPropertyGrid::GetMarginColour | ( |  | ) | const

Returns background colour of margin.

## ◆ GetMarginWidth()

int wxPropertyGrid::GetMarginWidth | ( |  | ) | const

Returns margin width.

## ◆ GetPanel()

wxWindow * wxPropertyGrid::GetPanel | ( |  | ) |

Returns wxWindow that the properties are painted on, and which should be used as the parent for editor controls.

## ◆ GetRoot()

wxPGProperty * wxPropertyGrid::GetRoot | ( |  | ) | const

Returns "root property".

It does not have name, etc. and it is not visible. It is only useful for accessing its children.

## ◆ GetRowHeight()

int wxPropertyGrid::GetRowHeight | ( |  | ) | const

Returns height of a single grid row (in pixels).

## ◆ GetSelectedProperty()

wxPGProperty * wxPropertyGrid::GetSelectedProperty | ( |  | ) | const

Returns currently selected property.

## ◆ GetSelection()

wxPGProperty * wxPropertyGrid::GetSelection | ( |  | ) | const

Returns currently selected property.

## ◆ GetSelectionBackgroundColour()

wxColour wxPropertyGrid::GetSelectionBackgroundColour | ( |  | ) | const

Returns current selection background colour.

## ◆ GetSelectionForegroundColour()

wxColour wxPropertyGrid::GetSelectionForegroundColour | ( |  | ) | const

Returns current selection text colour.

## ◆ GetSortFunction()

wxPGSortCallback wxPropertyGrid::GetSortFunction | ( |  | ) | const

Returns the property sort function (default is NULL).

See also
  SetSortFunction

## ◆ GetSplitterPosition()

int wxPropertyGrid::GetSplitterPosition | ( | unsigned int | splitterIndex = 0 | ) | const

Returns current splitter x position.

## ◆ GetStatusBar()

virtual wxStatusBar * wxPropertyGrid::GetStatusBar | ( |  | ) |
| virtual

Return wxStatusBar that is used by this wxPropertyGrid.

You can reimplement this member function in derived class to override the default behaviour of using the top-level wxFrame's status bar, if any.

## ◆ GetUncommittedPropertyValue()

wxVariant wxPropertyGrid::GetUncommittedPropertyValue | ( |  | ) |

Returns most up-to-date value of selected property.

This will return value different from GetSelectedProperty()->GetValue() only when text editor is activate and string edited by user represents valid, uncommitted property value.

## ◆ GetUnspecifiedValueAppearance()

const wxPGCell & wxPropertyGrid::GetUnspecifiedValueAppearance | ( |  | ) | const

Returns current appearance of unspecified value cells.

See also
  SetUnspecifiedValueAppearance()

## ◆ GetUnspecifiedValueText()

wxString wxPropertyGrid::GetUnspecifiedValueText | ( | int | argFlags = 0 | ) | const

Returns (visual) text representation of the unspecified property value.

Parameters

  argFlags | For internal use only.

## ◆ GetVerticalSpacing()

int wxPropertyGrid::GetVerticalSpacing | ( |  | ) | const

Returns current vertical spacing.

## ◆ HitTest()

wxPropertyGridHitTestResult wxPropertyGrid::HitTest | ( | const wxPoint & | pt | ) | const

Returns information about arbitrary position in the grid.

Parameters

  pt | Coordinates in the virtual grid space. You may need to use wxScrolled<T>::CalcScrolledPosition() for translating wxPropertyGrid client coordinates into something this member function can use.

## ◆ IsAnyModified()

bool wxPropertyGrid::IsAnyModified | ( |  | ) | const

Returns true if any property has been modified by the user.

## ◆ IsEditorFocused()

bool wxPropertyGrid::IsEditorFocused | ( |  | ) | const

Returns true if a property editor control has focus.

## ◆ IsEditorsValueModified()

bool wxPropertyGrid::IsEditorsValueModified | ( |  | ) | const

Returns true if editor's value was marked modified.

## ◆ IsFrozen()

bool wxPropertyGrid::IsFrozen | ( |  | ) | const

Returns true if updating is frozen (i.e.

Freeze() called but not yet Thaw() ).

## ◆ MakeColumnEditable()

void wxPropertyGrid::MakeColumnEditable | ( | unsigned int | column,
|  | bool | editable = true )

Makes given column editable by user.

Parameters

  column | The index of the column to make editable.
  editable | Using false here will disable column from being editable.

Note that column must not be equal to 1, as the second column is always editable and can be made read-only only on cell-by-cell basis using

wxPGProperty::ChangeFlag(wxPG_PROP_READONLY, true)
wxPGProperty::ChangeFlag
void ChangeFlag(wxPGPropertyFlags flag, bool set)
Sets or clears given property flag.
wxPG_PROP_READONLY
@ wxPG_PROP_READONLY
Property is read-only.
Definition property.h:330

See also
  BeginLabelEdit(), EndLabelEdit()

## ◆ OnTLPChanging()

void wxPropertyGrid::OnTLPChanging | ( | wxWindow * | newTLP | ) |

It is recommended that you call this function any time your code causes wxPropertyGrid's top-level parent to change.

wxPropertyGrid's OnIdle() handler should be able to detect most changes, but it is not perfect.

Parameters

  newTLP | New top-level parent that is about to be set. Old top-level parent window should still exist as the current one.

Remarks
  This function is automatically called from wxPropertyGrid:: Reparent() and wxPropertyGridManager::Reparent(). You only need to use it if you reparent wxPropertyGrid indirectly.

## ◆ RefreshEditor()

void wxPropertyGrid::RefreshEditor | ( |  | ) |

Refreshes any active editor control.

## ◆ RefreshProperty()

virtual void wxPropertyGrid::RefreshProperty | ( | wxPGProperty * | p | ) |
| virtual

Redraws given property.

Implements wxPropertyGridInterface.

## ◆ RegisterEditorClass()

wxPGEditor * wxPropertyGrid::RegisterEditorClass | ( | wxPGEditor * | editor,
|  | bool | noDefCheck = false )
| static

Forwards to DoRegisterEditorClass with empty name.

## ◆ RemoveFromSelection()

bool wxPropertyGrid::RemoveFromSelection | ( | wxPGPropArg | id | ) |

Removes given property from selection.

If property is not selected, an assertion failure will occur.

## ◆ ResetColours()

void wxPropertyGrid::ResetColours | ( |  | ) |

Resets all colours to the original system values.

## ◆ ResetColumnSizes()

void wxPropertyGrid::ResetColumnSizes | ( | bool | enableAutoResizing = false | ) |

Resets column sizes and splitter positions, based on proportions.

Parameters

  enableAutoResizing | If true, automatic column resizing is enabled (only applicable if window style wxPG_SPLITTER_AUTO_CENTER is used).

See also
  wxPropertyGridInterface::SetColumnProportion()

## ◆ SelectProperty()

bool wxPropertyGrid::SelectProperty | ( | wxPGPropArg | id,
|  | bool | focus = false )

Selects a property.

Editor widget is automatically created, but not focused unless focus is true.

Parameters

  id | Property to select (name or pointer).
  focus | If true, move keyboard focus to the created editor right away.

Returns
  returns true if selection finished successfully. Usually only fails if current value in editor is not valid.

Remarks
  In wxWidgets 2.9 and later, this function no longer sends `wxEVT_PG_SELECTED`.
  This clears any previous selection.

See also
  wxPropertyGridInterface::ClearSelection()

## ◆ SetCaptionBackgroundColour()

void wxPropertyGrid::SetCaptionBackgroundColour | ( | const wxColour & | col | ) |

Sets category caption background colour.

## ◆ SetCaptionTextColour()

void wxPropertyGrid::SetCaptionTextColour | ( | const wxColour & | col | ) |

Sets category caption text colour.

## ◆ SetCellBackgroundColour()

void wxPropertyGrid::SetCellBackgroundColour | ( | const wxColour & | col | ) |

Sets default cell background colour - applies to property cells.

Note that appearance of editor widgets may not be affected.

## ◆ SetCellDisabledTextColour()

void wxPropertyGrid::SetCellDisabledTextColour | ( | const wxColour & | col | ) |

Sets cell text colour for disabled properties.

## ◆ SetCellTextColour()

void wxPropertyGrid::SetCellTextColour | ( | const wxColour & | col | ) |

Sets default cell text colour - applies to property name and value text.

Note that appearance of editor widgets may not be affected.

## ◆ SetColumnCount()

void wxPropertyGrid::SetColumnCount | ( | int | colCount | ) |

Set number of columns (2 or more).

## ◆ SetCurrentCategory()

void wxPropertyGrid::SetCurrentCategory | ( | wxPGPropArg | id | ) |

Sets the 'current' category - Append will add non-category properties under it.

## ◆ SetEmptySpaceColour()

void wxPropertyGrid::SetEmptySpaceColour | ( | const wxColour & | col | ) |

Sets colour of empty space below properties.

## ◆ SetLineColour()

void wxPropertyGrid::SetLineColour | ( | const wxColour & | col | ) |

Sets colour of lines between cells.

## ◆ SetMarginColour()

void wxPropertyGrid::SetMarginColour | ( | const wxColour & | col | ) |

Sets background colour of margin.

## ◆ SetSelection()

void wxPropertyGrid::SetSelection | ( | const wxArrayPGProperty & | newSelection | ) |

Set entire new selection from given list of properties.

## ◆ SetSelectionBackgroundColour()

void wxPropertyGrid::SetSelectionBackgroundColour | ( | const wxColour & | col | ) |

Sets selection background colour - applies to selected property name background.

## ◆ SetSelectionTextColour()

void wxPropertyGrid::SetSelectionTextColour | ( | const wxColour & | col | ) |

Sets selection foreground colour - applies to selected property name text.

## ◆ SetSortFunction()

void wxPropertyGrid::SetSortFunction | ( | wxPGSortCallback | sortFunction | ) |

Sets the property sorting function.

Parameters

  sortFunction | The sorting function to be used. It should return a value greater than 0 if position of p1 is after p2. So, for instance, when comparing property names, you can use following implementation:

int MyPropertySortFunction(wxPropertyGrid* propGrid,
wxPGProperty* p1,
wxPGProperty* p2)
{
return p1->GetBaseName().compare( p2->GetBaseName() );
}
wxPGProperty
wxPGProperty is base class for all wxPropertyGrid properties and as such it is not intended to be ins...
Definition property.h:882
wxPGProperty::GetBaseName
const wxString & GetBaseName() const
Returns property's base name (i.e.
wxPropertyGrid::wxPropertyGrid
wxPropertyGrid()
Two step constructor.
wxString::compare
int compare(const wxString &str) const

Remarks
  Default property sort function sorts properties by their labels (case-insensitively).

See also
  GetSortFunction, wxPropertyGridInterface::Sort, wxPropertyGridInterface::SortChildren

## ◆ SetSplitterLeft()

void wxPropertyGrid::SetSplitterLeft | ( | bool | privateChildrenToo = false | ) |

Moves splitter as left as possible, while still allowing all labels to be shown in full.

Parameters

  privateChildrenToo | If false, will still allow private children to be cropped.

## ◆ SetSplitterPosition()

void wxPropertyGrid::SetSplitterPosition | ( | int | newxpos,
|  | int | col = 0 )

Sets x coordinate of the splitter.

Remarks
  Splitter position cannot exceed grid size, and therefore setting it during form creation may fail as initial grid size is often smaller than desired splitter position, especially when sizers are being used.

## ◆ SetUnspecifiedValueAppearance()

void wxPropertyGrid::SetUnspecifiedValueAppearance | ( | const wxPGCell & | cell | ) |

Sets appearance of value cells representing an unspecified property value.

Default appearance is blank.

Remarks
  If you set the unspecified value to have any textual representation, then that will override "InlineHelp" attribute.

See also
  wxPGProperty::SetValueToUnspecified(), wxPGProperty::IsValueUnspecified()

## ◆ SetupTextCtrlValue()

void wxPropertyGrid::SetupTextCtrlValue | ( | const wxString & | text | ) |

Must be called in wxPGEditor::CreateControls() if primary editor window is wxTextCtrl, just before textctrl is created.

Parameters

  text | Initial text value of created wxTextCtrl.

## ◆ SetVerticalSpacing()

void wxPropertyGrid::SetVerticalSpacing | ( | int | vspacing | ) |

Sets vertical spacing.

Can be 1, 2, or 3 - a value relative to font height. Value of 2 should be default on most platforms.

## ◆ SetVirtualWidth()

void wxPropertyGrid::SetVirtualWidth | ( | int | width | ) |

Set virtual width for this particular page.

Width -1 indicates that the virtual width should be disabled.

## ◆ ShowPropertyError()

void wxPropertyGrid::ShowPropertyError | ( | wxPGPropArg | id,
|  | const wxString & | msg )

Shows a brief error message that is related to a property.

## ◆ UnfocusEditor()

bool wxPropertyGrid::UnfocusEditor | ( |  | ) |

Unfocuses or closes editor if one was open, but does not deselect property.

## ◆ ValueChangeInEvent()

void wxPropertyGrid::ValueChangeInEvent | ( | wxVariant | variant | ) |

Call this from wxPGProperty::OnEvent() to cause property value to be changed after the function returns (with true as return value).

ValueChangeInEvent() must be used if you wish the application to be able to use wxEVT_PG_CHANGING to potentially veto the given value.

## ◆ WasValueChangedInEvent()

bool wxPropertyGrid::WasValueChangedInEvent | ( |  | ) | const

You can use this member function, for instance, to detect in wxPGProperty::OnEvent() if wxPGProperty::SetValueInEvent() was already called in wxPGEditor::OnEvent().

It really only detects if was value was changed using wxPGProperty::SetValueInEvent(), which is usually used when a 'picker' dialog is displayed. If value was written by "normal means" in wxPGProperty::StringToValue() or IntToValue(), then this function will return false (on the other hand, wxPGProperty::OnEvent() is not even called in those cases).